<?php
/**
 * ------------------------------------------------------------------------
 * JA Megafilter Component
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class JaMegaFilterViewDefault extends JViewLegacy
{
	protected $_layout_path = array();
	
	protected $_css_path = array();
	
	function display($tpl = null)
	{
		$app = JFactory::getApplication();
		$this->item = $this->get('Item');
		
		if (empty($this->item)) {
			$app->enqueueMessage(JText::_('COM_JAMEGAFILTER_UNDEFINED_MENU_ID'), 'error');
			return;
		}
		
		if (empty($this->item['published'])) {
			$app->enqueueMessage(JText::_('COM_JAMEGAFILTER_ITEM_UNPUBLISHED'), 'error');
			return;
		}
		
		if ( !JaMegaFilterHelper::getComponentStatus('com_'.$this->item['type']) ) {
			$app->enqueueMessage(JText::_('COM_JAMEGAFILTER_COMPONENT_NOT_FOUND'), 'error');
			return;
		}

		$this->config = $this->_getFilterConfig($this->item);
		
		$jatype = $this->item['type'];

		$this->_addCss($jatype);
		
		$this->_addLayoutPath($jatype);

		$this->jstemplate = $this->_loadJsTemplate();

		if ($jatype === 'blank') {
			parent::display($tpl);
		} else {
			JPluginHelper::importPlugin('jamegafilter');
			$dispatcher = JEventDispatcher::getInstance();
			$dispatcher->trigger('onBeforeDisplay'.ucfirst($jatype).'Items', array( $this->jstemplate, $this->config ) );
		}
	}
	
	protected function _getFilterConfig($item)
	{
		$config = new stdClass();
		$jinput = JFactory::getApplication()->input;
		$itp = $jinput->get('itemperpage', 10, 'INT');
		$paginate = array($itp, $itp*2, $itp*3, $itp*4);
		
		$params = json_decode($this->item['params']);
		$fields = array();
		$sorts = array();
		$sorts[] = array('field'=>'', 'title'=> JText::_('JPOSITION'));
		if ( !empty($params->javmfield)) {
			foreach ($params->javmfield AS $k => $param) {
				if ($param->type != null && $param->type != '0' && $param->type != 'disabled') {
					$fields[] = array('type'=>$param->type, 'title'=>$param->title, 'field'=>$param->field, 'frontend_field'=>str_replace('.value','.frontend_value',$param->field));
					$sorts[] = array('field'=>$param->field, 'title'=>$param->title);
				}
			}
		}
		
		if ( !empty($params->javmcustomfield)) {
			foreach ($params->javmcustomfield->type AS $k => $param) {
				if ($param != null && $param != '0' && $param != 'disabled') {
					$fields[] = array('type'=>$param, 'title'=>$params->javmcustomfield->title->{$k}, 'field'=>'jact.ct'.$k.'.frontend_value');
					$sorts[] = array('field'=>'jact.ct'.$k.'.frontend_value', 'title'=>$params->javmcustomfield->title->{$k});
				}
			}
		}
		
		$lang_tag = JFactory::getLanguage()->getTag();
		$lang_suffix = str_replace('-', '_', strtolower($lang_tag));
		$config->json = '/media/com_jamegafilter/'.$lang_suffix.'/'.$this->item['id'].'.json';
		
		$config->paginate = $paginate;
		$config->sorts = $sorts;
		$config->fields = $fields;
		return $config;
	}
	
	protected function _loadJsTemplate()
	{
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		
		$template_names = array();

		$layouts_path = JPATH_COMPONENT.'/layouts';
		$filter_path = $layouts_path.'/filter';
		
		$base_files = JFolder::files($layouts_path);
		foreach ($base_files as $base) {
			$template_names[] = JFile::stripExt($base);
		}
		
		$filter_files = JFolder::files($filter_path);
		foreach ($filter_files as $filter) {
			$template_names[] = JFile::stripExt($filter);
		}
		
		$jstemplate = new stdClass();
		foreach ($template_names as $name) {
			$jstemplate-> { $name } = $this->_loadLayout($name);
		}
		
		return $jstemplate;
	}
	
	protected function _addLayoutPath($jatype)
	{
		$app = JFactory::getApplication();
		
		$layouts_path = JPATH_COMPONENT.'/layouts';
		
		$filter_path = $layouts_path.'/filter';
		
		$fallback = JPATH_THEMES . '/' . $app->getTemplate() . '/html/layouts/jamegafilter/'. $jatype;

		$filter_fallback = $fallback.'/filter';
		
		$plugin_path = JPATH_PLUGINS.'/jamegafilter/'.$jatype.'/layouts';
		
		$filter_plugin_path = $plugin_path.'/filter';
		
		// add template path
		array_unshift($this->_layout_path, $filter_path);

		array_unshift($this->_layout_path, $layouts_path);
		
		array_unshift($this->_layout_path, $filter_plugin_path);

		array_unshift($this->_layout_path, $plugin_path);

		array_unshift($this->_layout_path, $filter_fallback);
		
		array_unshift($this->_layout_path, $fallback);
		
		return;
	}
	
	protected function _loadLayout($name)
	{
		// Clear prior output
		$this->_output = null;

		// Load the template script
		jimport('joomla.filesystem.path');
		
		$filename = preg_replace('/[^A-Z0-9_\.-]/i', '', $name);
		
		$file = JPath::find($this->_layout_path, $filename.'.php');

		if ($file != false) {
			
			ob_start();

			include $file;

			$this->_output = ob_get_contents();
			ob_end_clean();

			return $this->_output;
		
		} else {
			throw new Exception(JText::sprintf('JLIB_APPLICATION_ERROR_LAYOUTFILE_NOT_FOUND', $name.'.php'), 500);
		}
	}

	protected function _addCss($jatype)
	{
		$app = JFactory::getApplication();
		$doc = JFactory::getDocument();
		$component = JApplicationHelper::getComponentName();

		if(file_exists(JPATH_THEMES . '/' . $app->getTemplate() . '/css/jamegafilter/'. $jatype.'/style.css')) 
		{
			$doc->addStyleSheet(JURI::root(true).'/templates/'.$app->getTemplate().'/css/jamegafilter/'. $jatype.'/style.css');

		} else if(file_exists(JPATH_PLUGINS.'/jamegafilter/'.$jatype.'/assets/css/style.css')) 
		{
			$doc->addStyleSheet(JURI::root(true).'/plugins/jamegafilter/'.$jatype.'/assets/css/style.css');

		} else {
			$doc->addStyleSheet(JURI::root(true).'/components/'.$component.'/assets/css/style.css');
		}

	}
}