<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport('joomla.form.formfield');

class JFormFieldVM extends JFormField
{
	protected $type = 'VM';
	
	protected function addOptions($value, $text, $current) {
		return '<option '.((!empty($current) && $current == $value) ? ' selected="selected" ' : '').' value="'.$value.'">'.$text.'</option>';
	}
	
	protected function filterType($value, $id) {
// 		'.$this->addOptions("value", "Textbox", $val).'
// 		'.$this->addOptions("range", "Range", $val).'
// 		'.$this->addOptions("list", "List", $val).'
		$val = !empty($value['type'][$id]) ? $value['type'][$id] : 0;
		return '<select name="'.$this->name.'[type]['.$id.']">
			<option value="0">'.JText::_('JSELECT').'</option>
			'.$this->addOptions("disabled", JText::_('JDISABLED'), $val).'
			'.$this->addOptions("dropdown", "Dropdown", $val).'
			'.$this->addOptions("single", "Radio", $val).'
			'.$this->addOptions("multiple", "Checkbox", $val).'
		</select>';
	}
	
	protected function getType($code) {
		if ($code == 'S')
			return 'STRING';
		else if ($code == 'P')
			return 'PROPERTY';
		else if ($code == 'B')
			return 'BOOLEAN';
		else if ($code == 'D')
			return 'DATE';
		else if ($code == 'T')
			return 'TIME';
		else if ($code == 'M')
			return 'IMAGE';
		else if ($code == 'X')
			return 'EDITOR';
		else if ($code == 'Y')
			return 'TEXTAREA';
		else if ($code == 'C')
			return 'MULTI VARIANT';
		else if ($code == 'A')
			return 'GENERIC CHILD VARIANT';
		else if ($code == 'E')
			return 'PLUG_IN';
		else if ($code == 'G')
			return 'CUSTOM GROUP';
		else if ($code == 'R')
			return 'RELATE PRODUCT';
		else if ($code == 'Z')
			return 'RELATE CATEGORY';
	}
	

	protected function getInput()
	{
		$lang = JFactory::getLanguage();
		$extension = 'com_virtuemart';
		$base_dir = JPATH_ADMINISTRATOR.'/components/com_virtuemart';
		$language_tag = $lang->getTag();
		$reload = true;
		$lang->load($extension, $base_dir, $language_tag, $reload);
		$html='';
		$value = array();
		$value['type'] = array();
		$value['published'] = array();
		if (!empty($this->value)) {
			$value = $this->value;
		}
		
		$db    = JFactory::getDbo();
		$query = $db->getQuery(true);

		// Create the base select statement.
		$query->select('*')
			  ->from($db->quoteName('#__virtuemart_customs'));
		$db->setQuery($query);
		$items = $db->loadObjectList();
		
		$html .= '<table class="table table-striped table-hover">';
		$html .= '<tr><td>'.JText::_('COM_JAMEGAFILTER_TITLE').'</td><td>'.JText::_('COM_JAMEGAFILTER_TYPE').'</td><td>'.JText::_('COM_JAMEGAFILTER_PARAM').'</td></tr>';
		foreach ($items AS $item) {
			if (!in_array($item->field_type, array('S'))) continue;
			$html .= '<tr>';
				$html .= '<td>'.JText::_($item->custom_title).'</td>';
				$html .= '<td>'.$this->getType($item->field_type).'</td>';
				$html .= '<td>'.$this->filterType($value, $item->virtuemart_custom_id).'
				<input type="hidden" name="'.$this->name.'[title]['.$item->virtuemart_custom_id.']" value="'.(string)$item->custom_title.'" />
				</td>';
			$html .= '</tr>';
		}
		$html .= '</table>';

		return $html;
	}
}